﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Private timMessages1 As Timer
	Private timMessages2 As Timer
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	'v0.1  (16/11/2021) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label
	
	Private pnlMessages As Panel
	Private lblMessages As Label
	Private strMessagesText As String

	Private lblMondayAvailability As Label
	Private lblTuesdayAvailability As Label
	Private lblWednesdayAvailability As Label
	Private lblThursdayAvailability As Label
	Private lblFridayAvailability As Label
	Private lblSaturdayAvailability As Label
	Private lblSundayAvailability As Label
	
	Private strSQLQuery As String
	
	Private WADefaultCodesSet As ResultSet
	Private intDefaultCodesDayNumber As Int
	Private intDefaultCodesAvailabilityCode As Int
	
	Private lstAvailabilityDescription(1) As List
	Private whlAvailabilityDescription As clsWheel

	Private WACodesSet As ResultSet
	Private strCodesAvailabilityDescription As String
	
	Private strNothing As String = ""

End Sub

Sub Activity_Create(FirstTime As Boolean)

	Activity.LoadLayout("WAS20")
	
	lblVersion.Text = strVersion

	SelectCodesAvailabilityDescriptionList
	
	SelectDefaultCodesRecords

	Do While WADefaultCodesSet.NextRow
		intDefaultCodesDayNumber = WADefaultCodesSet.GetInt("DefaultCodesDayNumber")
		intDefaultCodesAvailabilityCode = WADefaultCodesSet.GetInt("DefaultCodesAvailabilityCode")
		SelectCodesAvailabilityDescription
		Select intDefaultCodesDayNumber
			Case 1
				lblMondayAvailability.Text = strCodesAvailabilityDescription
			Case 2
				lblTuesdayAvailability.Text = strCodesAvailabilityDescription
			Case 3
				lblWednesdayAvailability.Text = strCodesAvailabilityDescription
			Case 4
				lblThursdayAvailability.Text = strCodesAvailabilityDescription
			Case 5
				lblFridayAvailability.Text = strCodesAvailabilityDescription
			Case 6
				lblSaturdayAvailability.Text = strCodesAvailabilityDescription
			Case 7
				lblSundayAvailability.Text = strCodesAvailabilityDescription
		End Select
	Loop
	
	timMessages1.Initialize("timMessages1", 500)
	timMessages1.Enabled = False
	timMessages2.Initialize("timMessages2", 4600)
	timMessages2.Enabled = False

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

'DATABASE CALLS
'==============

'SELECT DATABASE RECORDS
'=======================

Sub SelectCodesAvailabilityDescriptionList

	lstAvailabilityDescription(0).Initialize
	
	strSQLQuery = "Select * FROM Codes ORDER BY CodesAvailabilityCode ASC"
	
	WACodesSet = Main.SQLWA.ExecQuery(strSQLQuery)
	Do While WACodesSet.NextRow
		lstAvailabilityDescription(0).Add(WACodesSet.GetString("CodesAvailabilityDescription"))
	Loop

	whlAvailabilityDescription.Initialize(Me, Activity, "  Default Availability  ", 1, lstAvailabilityDescription, 34, 4, False)

End Sub

Sub SelectDefaultCodesRecords

	strSQLQuery = "Select * FROM DefaultCodes ORDER BY DefaultCodesDayNumber ASC"

	WADefaultCodesSet = Main.SQLWA.ExecQuery(strSQLQuery)

End Sub

Sub SelectCodesAvailabilityCode
	
	strSQLQuery = "Select CodesAvailabilityCode FROM Codes "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityDescription = ?"

	intDefaultCodesAvailabilityCode = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(strCodesAvailabilityDescription))

End Sub

Sub SelectCodesAvailabilityDescription
	
	strSQLQuery = "Select CodesAvailabilityDescription FROM Codes "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityCode = ?"

	strCodesAvailabilityDescription = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
				Array As String(intDefaultCodesAvailabilityCode))	

End Sub

'UPDATE DATABASE RECORDS
'=======================

Sub UpdateDefaultCodesRecord
	
	strSQLQuery = "UPDATE DefaultCodes Set DefaultCodesAvailabilityCode = ? WHERE DefaultCodesDayNumber = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(intDefaultCodesAvailabilityCode, intDefaultCodesDayNumber))	
	
End Sub

'CLICK EVENTS
'============

Sub lblMondayAvailability_Click

	whlAvailabilityDescription.Show2("lblMondayAvailability", lblMondayAvailability.Text)

End Sub

Sub lblTuesdayAvailability_Click

	whlAvailabilityDescription.Show2("lblTuesdayAvailability", lblTuesdayAvailability.Text)

End Sub

Sub lblWednesdayAvailability_Click

	whlAvailabilityDescription.Show2("lblWednesdayAvailability", lblWednesdayAvailability.Text)

End Sub

Sub lblThursdayAvailability_Click

	whlAvailabilityDescription.Show2("lblThursdayAvailability", lblThursdayAvailability.Text)

End Sub

Sub lblFridayAvailability_Click

	whlAvailabilityDescription.Show2("lblFridayAvailability", lblFridayAvailability.Text)

End Sub

Sub lblSaturdayAvailability_Click

	whlAvailabilityDescription.Show2("lblSaturdayAvailability", lblSaturdayAvailability.Text)

End Sub

Sub lblSundayAvailability_Click

	whlAvailabilityDescription.Show2("lblSundayAvailability", lblSundayAvailability.Text)

End Sub

Sub imgExit_Click
	
	Activity.Finish

End Sub

'TICK EVENTS
'===========

Sub timMessages1_Tick
		
	If lblMessages.Text = strNothing Then
		lblMessages.Text = strMessagesText
	Else
		lblMessages.Text = strNothing
	End If
	
End Sub

Sub timMessages2_Tick
		
	timMessages1.Enabled = False
	timMessages2.Enabled = False
	
End Sub

'CLOSED EVENTS
'=============

Sub lblMondayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		If lblMondayAvailability.Text <> Selection Then
			lblMondayAvailability.Text = Selection
			strCodesAvailabilityDescription = Selection
			SelectCodesAvailabilityCode
			intDefaultCodesDayNumber = 1
			UpdateDefaultCodesRecord
			lblMessages.Text = "Monday Default Updated"
			strMessagesText = lblMessages.Text
			timMessages1.Enabled = True
			timMessages2.Enabled = True
		End If
	End If

End Sub

Sub lblTuesdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		If lblTuesdayAvailability.Text <> Selection Then
			lblTuesdayAvailability.Text = Selection
			strCodesAvailabilityDescription = Selection
			SelectCodesAvailabilityCode
			intDefaultCodesDayNumber = 2
			UpdateDefaultCodesRecord
			lblMessages.Text = "Tuesday Default Updated"
			strMessagesText = lblMessages.Text
			timMessages1.Enabled = True
			timMessages2.Enabled = True
		End If
	End If

End Sub

Sub lblWednesdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		If lblWednesdayAvailability.Text <> Selection Then
			lblWednesdayAvailability.Text = Selection
			strCodesAvailabilityDescription = Selection
			SelectCodesAvailabilityCode
			intDefaultCodesDayNumber = 3
			UpdateDefaultCodesRecord
			lblMessages.Text = "Wednesday Default Updated"
			strMessagesText = lblMessages.Text
			timMessages1.Enabled = True
			timMessages2.Enabled = True
		End If
	End If

End Sub

Sub lblThursdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		If lblThursdayAvailability.Text <> Selection Then
			lblThursdayAvailability.Text = Selection
			strCodesAvailabilityDescription = Selection
			SelectCodesAvailabilityCode
			intDefaultCodesDayNumber = 4
			UpdateDefaultCodesRecord
			lblMessages.Text = "Thursday Default Updated"
			strMessagesText = lblMessages.Text
			timMessages1.Enabled = True
			timMessages2.Enabled = True
		End If
	End If

End Sub

Sub lblFridayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		If lblFridayAvailability.Text <> Selection Then
			lblFridayAvailability.Text = Selection
			strCodesAvailabilityDescription = Selection
			SelectCodesAvailabilityCode
			intDefaultCodesDayNumber = 5
			UpdateDefaultCodesRecord
			lblMessages.Text = "Friday Default Updated"
			strMessagesText = lblMessages.Text
			timMessages1.Enabled = True
			timMessages2.Enabled = True
		End If
	End If

End Sub

Sub lblSaturdayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		If lblSaturdayAvailability.Text <> Selection Then
			lblSaturdayAvailability.Text = Selection
			strCodesAvailabilityDescription = Selection
			SelectCodesAvailabilityCode
			intDefaultCodesDayNumber = 6
			UpdateDefaultCodesRecord
			lblMessages.Text = "Saturday Default Updated"
			strMessagesText = lblMessages.Text
			timMessages1.Enabled = True
			timMessages2.Enabled = True
		End If
	End If
End Sub

Sub lblSundayAvailability_Closed (Cancelled As Boolean, Selection As String)

	If Cancelled = False Then
		If lblSundayAvailability.Text <> Selection Then
			lblSundayAvailability.Text = Selection
			strCodesAvailabilityDescription = Selection
			SelectCodesAvailabilityCode
			intDefaultCodesDayNumber = 7
			UpdateDefaultCodesRecord
			lblMessages.Text = "Sunday Default Updated"
			strMessagesText = lblMessages.Text
			timMessages1.Enabled = True
			timMessages2.Enabled = True
		End If
	End If

End Sub