﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private XUI As XUI
	
	Private timMessages1 As Timer
	Private timMessages2 As Timer
		
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private IME As IME

	'v0.1  (20/11/2021) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label

	Private clvPanel As CustomListView
	
	Private lblCode As Label
	Private lblCodeDescription As Label
	
'	Private lbledtCodeDescriptionLabel As Label
	Private edtCode As EditText
	Private edtCodeDescription As EditText
	Private lblButton As Label
	Private edtDummy As EditText

	Private lblMessages As Label
	Private strMessagesText As String

	Private strSQLQuery As String
	
	Private WACodesSet As ResultSet
	Private intCodesAvailabilityCode As Int
	Private strCodesAvailabilityDescription As String

	Private outCode As String
	Private outCodeDescription As String

	Private int0 As Int = 0
	Private strNothing As String = ""
	Private intTotalAvailabilityCodes As Int
	Private intTotalDefaultCodes As Int
	Private intTotalCode As Int
	Private intTotalCodeDescription As Int

	Private bolKeyboardVisible As Boolean = False
	Private bolTestForExistingCodes As Boolean
	Private bolValidCode As Boolean
	Private bolValidCodeAvailability As Boolean

End Sub

Sub Activity_Create(FirstTime As Boolean)

	IME.Initialize("IME")

	Activity.LoadLayout("WAS30")
	
	lblVersion.Text = strVersion

	IME.SetLengthFilter(edtCode, 2)
'	edtCode.InputType = Bit.Or(edtCode.INPUT_TYPE_PHONE, 8192)
	IME.SetLengthFilter(edtCodeDescription, 25)
'	edtCodeDescription.InputType = Bit.Or(edtCodeDescription.INPUT_TYPE_TEXT, 8192)
	
	SelectCodes
	
	timMessages1.Initialize("timMessages1", 400)
	timMessages1.Enabled = False
	timMessages2.Initialize("timMessages2", 2600)
	timMessages2.Enabled = False
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub CreateItem As B4XView

	Dim p As B4XView = XUI.CreatePanel("")
	
	p.SetLayoutAnimated(0, 0, 0, 100%x, 36dip)
	p.LoadLayout("WAS30clv")
	
	lblCode.Text = outCode
	lblCodeDescription.Text = outCodeDescription

	Return p
	
End Sub

'SELECT DATABASE CALLS
'=====================

Sub SelectCodes
	
	strSQLQuery = "Select * FROM Codes ORDER BY CodesAvailabilityCode ASC"
	
	WACodesSet = Main.SQLWA.ExecQuery(strSQLQuery)

	clvPanel.Clear
	clvPanel.sv.Visible = False
	
	Do While WACodesSet.NextRow
		outCode = WACodesSet.GetInt("CodesAvailabilityCode")
		outCodeDescription = WACodesSet.GetString("CodesAvailabilityDescription")
		Log(outCode & " " & outCodeDescription)
		clvPanel.Add(CreateItem, outCode)
	Loop
	
	clvPanel.sv.Visible = True

End Sub

Sub SelectCodesDescription

	strSQLQuery = "Select CodesAvailabilityDescription FROM Codes "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityCode = ?"
	
	strCodesAvailabilityDescription = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intCodesAvailabilityCode))

End Sub

Sub SelectTestForAvailabilityCodes

	strSQLQuery = "Select count(*) FROM Availability "
	strSQLQuery = strSQLQuery & "WHERE AvailabilityMonday = ? "
	strSQLQuery = strSQLQuery & "OR AvailabilityTuesday = ? "
	strSQLQuery = strSQLQuery & "OR AvailabilityWednesday = ? "
	strSQLQuery = strSQLQuery & "OR AvailabilityThursday = ? "
	strSQLQuery = strSQLQuery & "OR AvailabilityFriday = ? "
	strSQLQuery = strSQLQuery & "OR AvailabilitySaturday = ? "
	strSQLQuery = strSQLQuery & "OR AvailabilitySunday = ?"
	
	intTotalAvailabilityCodes = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intCodesAvailabilityCode, intCodesAvailabilityCode, _
			intCodesAvailabilityCode, intCodesAvailabilityCode, intCodesAvailabilityCode, _
			intCodesAvailabilityCode, intCodesAvailabilityCode))

End Sub

Sub SelectTestForDefaultCodes

	strSQLQuery = "Select count(*) FROM DefaultCodes "
	strSQLQuery = strSQLQuery & "WHERE DefaultCodesAvailabilityCode = ? "
	
	intTotalDefaultCodes = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intCodesAvailabilityCode))

End Sub

Sub SelectTestCode

	Log("intCodesAvailabilityCode " & intCodesAvailabilityCode)
	strSQLQuery = "Select count(*) FROM Codes "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityCode = ? "
	
	intTotalCode = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intCodesAvailabilityCode))

	End Sub
	
	Sub SelectTestCodeDescription

	strSQLQuery = "Select count(*) FROM Codes "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityDescription = ? "
	
	intTotalCodeDescription = Main.SQLWA.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(strCodesAvailabilityDescription))

End Sub

'ADD DATABASE RECORDS
'====================

Sub InsertCodesRecord

	strSQLQuery = "INSERT INTO Codes VALUES "
	strSQLQuery = strSQLQuery & "(?, ?)"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
		Array As Object(intCodesAvailabilityCode, strCodesAvailabilityDescription))

End Sub

'DELETE DATABASE RECORDS
'=======================

Sub DeleteCodesRecord
	
	strSQLQuery = "DELETE FROM Codes WHERE CodesAvailabilityCode = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
		Array As Object(intCodesAvailabilityCode))

End Sub

'UPDATE DATABASE RECORDS
'=======================

Sub UpdateCodesAvailabilityDescription
	
	strSQLQuery = "UPDATE Codes Set CodesAvailabilityDescription = ? "
	strSQLQuery = strSQLQuery & "WHERE CodesAvailabilityCode = ?"

	Main.SQLWA.ExecNonQuery2(strSQLQuery, _
			Array As Object(strCodesAvailabilityDescription, intCodesAvailabilityCode))
	
End Sub

'CLICK EVENTS
'============

Sub clvPanel_ItemClick (Index As Int, Value As Object)

	If bolKeyboardVisible = False Then
		intCodesAvailabilityCode = Value
		SelectCodesDescription
		edtCode.Text = intCodesAvailabilityCode
		edtCode.Enabled = False
		edtCodeDescription.Text = strCodesAvailabilityDescription
		edtCodeDescription.Enabled = True
		lblButton.Text = "Update"
		lblButton.Enabled = False
	End If
	
End Sub
	
Sub lblButton_Click

	Select lblButton.Text
		Case "Add"
			TestCode
			If bolValidCode = True Then
				strCodesAvailabilityDescription = edtCodeDescription.Text
				TestCodeDescription
				If bolValidCodeAvailability = True Then
					InsertCodesRecord
					SelectCodes
					Main.spl.Play(Main.splPing, 1, 1, 1, 0, 1)
					lblMessages.Text = "Availability Code " & edtCode.Text & " Added"
					strMessagesText = lblMessages.Text
					timMessages1.Enabled = True
					timMessages2.Enabled = True
					edtCode.Text = strNothing
					edtCodeDescription.Text = strNothing
				End If
			End If
		Case "Update"
			strCodesAvailabilityDescription = edtCodeDescription.Text
			TestCodeDescription
			If bolValidCodeAvailability = True Then
				UpdateCodesAvailabilityDescription
				SelectCodes
				Main.spl.Play(Main.splPing, 1, 1, 1, 0, 1)
				lblMessages.Text = "Code " & edtCode.Text & " Availability Updated"
				strMessagesText = lblMessages.Text
				timMessages1.Enabled = True
				timMessages2.Enabled = True
				edtCode.Text = strNothing
				edtCode.Enabled = True
				edtCodeDescription.Text = strNothing
				lblButton.Text = "Add"
			End If
		Case "Delete"
			TestForExistingCodes
			If bolTestForExistingCodes = False Then
				DeleteCodesRecord
				SelectCodes
				Main.spl.Play(Main.splPing, 1, 1, 1, 0, 1)
				lblMessages.Text = "Availability Code " & edtCode.Text & " Deleted"
				strMessagesText = lblMessages.Text
				timMessages1.Enabled = True
				timMessages2.Enabled = True
			End If
			edtCode.Text = strNothing
			edtCode.Enabled = True
			edtCodeDescription.Text = strNothing
			edtCodeDescription.Enabled = True
			lblButton.Text = "Add"
	End Select

	edtDummy.RequestFocus
	lblButton.Enabled = False
	
End Sub

Sub imgExit_Click
	
	Activity.Finish

End Sub

'LONGCLICK EVENT
'================

Sub clvPanel_ItemLongClick (Index As Int, Value As Object)
	Log("bolKeyboardVisible " & bolKeyboardVisible)
	If bolKeyboardVisible = False Then
		intCodesAvailabilityCode = Value
		SelectCodesDescription
		edtCode.Text = intCodesAvailabilityCode
		edtCode.Enabled = False
		edtCodeDescription.Text = strCodesAvailabilityDescription
		edtCodeDescription.Enabled = False
		lblButton.Text = "Delete"
		lblButton.Enabled = True
	End If
	
End Sub

'FOCUSCHANGED EVENTS
'===================

Private Sub edtCode_FocusChanged (HasFocus As Boolean)
	
	Log("edtCode_FocusChanged ENTERED")
	If HasFocus = True Then
		edtCode.SelectionStart = edtCode.Text.Length
		lblButton.Enabled = False
		bolKeyboardVisible = True
		Log("++ bolKeyboardVisible " & bolKeyboardVisible)
	Else
		bolKeyboardVisible = False
	End If
	
End Sub

Private Sub edtCodeDescription_FocusChanged (HasFocus As Boolean)
	
	Log("edtCodeDescription_FocusChanged ENTERED")
	If HasFocus = True Then
		edtCodeDescription.SelectionStart = edtCodeDescription.Text.Length
		lblButton.Enabled = False
		bolKeyboardVisible = True
		Log("++ bolKeyboardVisible " & bolKeyboardVisible)
	Else
		bolKeyboardVisible = False
	End If
	
End Sub

'TICK EVENTS
'===========

Sub timMessages1_Tick
		
	If lblMessages.Text = strNothing Then
		lblMessages.Text = strMessagesText
	Else
		lblMessages.Text = strNothing
	End If
	
End Sub

Sub timMessages2_Tick
		
	timMessages1.Enabled = False
	timMessages2.Enabled = False
	
	lblMessages.TextColor = Colors.White
	
	lblMessages.Text = strNothing
	
End Sub

'ENTER PRESSED EVENTS
'====================

Sub edtCode_EnterPressed
	Log("lblButton Enabled " & lblButton.Enabled)
	
	IME.HideKeyboard
	
	bolKeyboardVisible = False
	
	If edtCode.Text.Length > int0 _
	 And edtCodeDescription.Text.Length > int0 Then
		lblButton.Enabled = True
	End If
	
	edtDummy.RequestFocus

	End Sub
	
Sub edtCodeDescription_EnterPressed
	Log("lblButton Enabled " & lblButton.Enabled)
	IME.HideKeyboard
	
	bolKeyboardVisible = False

	If edtCode.Text.Length > int0 _
	 And edtCodeDescription.Text.Length > int0 Then
		lblButton.Enabled = True
	End If
	
	edtDummy.RequestFocus

End Sub

'GENERAL ROUTINES
'================

Sub TestForExistingCodes
	
	bolTestForExistingCodes = True
	
	intTotalAvailabilityCodes = int0
	SelectTestForAvailabilityCodes
	
	intTotalDefaultCodes = int0
	SelectTestForDefaultCodes

	If intTotalAvailabilityCodes <> int0 _
	 Or intTotalDefaultCodes <> int0 Then
		Main.spl.Play(Main.splWarning, 1, 1, 1, 0, 1)
		lblMessages.TextColor = Colors.Red
		lblMessages.Text = "Availability Code " & intCodesAvailabilityCode & " Still In Use"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	Else
		bolTestForExistingCodes = False
	End If
	
End Sub

Sub TestCode
	
	bolValidCode = False
	
	intCodesAvailabilityCode = edtCode.Text
	intTotalCode = int0
	
	SelectTestCode
	
	Log("intTotalCode " & intTotalCode)
	
	If intTotalCode <> int0 Then
		Main.spl.Play(Main.splWarning, 1, 1, 1, 0, 1)
		lblMessages.TextColor = Colors.Red
		lblMessages.Text = "Code " & edtCode.Text & " Already Exists"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	Else
		bolValidCode = True
	End If
		
End Sub
	
Sub TestCodeDescription
	
	bolValidCodeAvailability = False
	
	intTotalCodeDescription = int0
	
	SelectTestCodeDescription
	
	If intTotalCodeDescription <> int0 Then
		Main.spl.Play(Main.splWarning, 1, 1, 1, 0, 1)
		lblMessages.TextColor = Colors.Red
		lblMessages.Text = "Availability Already Exists"
		strMessagesText = lblMessages.Text
		timMessages1.Enabled = True
		timMessages2.Enabled = True
	Else
		bolValidCodeAvailability = True
	End If
		
End Sub